
#ifndef TEMPLATE_H
#define TEMPLATE_H

template<class T> inline 
const T & _max ( const T & x, const T & y )
{
    return x < y ? y : x;
}

template<class T> inline 
const T & _min ( const T & x, const T & y )
{
    return x > y ? y : x;
}

template<class T> inline 
void _swap ( T & x, T & y )
{
    const T z ( x );
    x = y;
    y = z;
}

#endif