// TranslatorDoc.cpp : implementation of the CTranslatorDoc class
//

#include "stdafx.h"
#include "Translator.h"

#include "TranslatorDoc.h"
#include "TranslatorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTranslatorDoc

IMPLEMENT_DYNCREATE(CTranslatorDoc, CDocument)

BEGIN_MESSAGE_MAP(CTranslatorDoc, CDocument)
	//{{AFX_MSG_MAP(CTranslatorDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTranslatorDoc construction/destruction

CTranslatorDoc::CTranslatorDoc()
{
}

CTranslatorDoc::~CTranslatorDoc()
{
}

BOOL CTranslatorDoc::OnNewDocument()
{

	((CEditView*)m_viewList.GetHead())->SetWindowText(NULL); //  CEditView,   .

	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CTranslatorDoc serialization

void CTranslatorDoc::Serialize ( CArchive & ar )
{	
	if (ar.IsStoring())
	{
	    CTranslatorView *pView = ( CTranslatorView * ) m_viewList.GetHead();
        long length = ( pView->GetRichEditCtrl() ).GetTextLength();
        char * str = new char[length];
        pView->GetWindowText ( str, length );
        ar.Write ( str, length );
        delete[] str;
	}
	else
	{
        CString str;
        const unsigned int bufsize = 256;
        char buf[bufsize];
        for(;;)
        {
            unsigned int n = ar.Read ( buf, bufsize );
            if ( n == 0 ) break;
            str += CString ( buf, n );
            if ( n < bufsize ) break;
        }
	    CTranslatorView *pView = ( CTranslatorView * ) m_viewList.GetHead();
        pView->SetWindowText(str);
        pView->colorize(); //     
    }
}

/////////////////////////////////////////////////////////////////////////////
// CTranslatorDoc diagnostics

#ifdef _DEBUG
void CTranslatorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTranslatorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTranslatorDoc commands
